## vowpal-wabbit 8.5.0.dfsg1

=== R/r.vw/DESCRIPTION ===
Package: r.vw
Type: Package
Title: interface between R and Vowpal Wabbit
Version: 0.1
Date: 2015-10-07
Authors@R: person("First", "Last", email = "first.last@example.com", role = c("aut", "cre"))
Description: More about what it does (maybe more than one line)
License: BSD
LazyData: TRUE
Imports: pROC,
    data.table,
    ggplot2
