=== debian/changelog ===
vowpal-wabbit (8.5.0.dfsg1-1) unstable; urgency=medium

  * Fresh upstream release
  * debian/control
    - added rapidjson-dev to build-depends
    - boosted policy to 4.1.3
    - boosted compat/debhelper to 9
    - "optional" priority instead of "extra" for -dbg to please lintian
  * debian/*.install
    - libraries are installed under usr/lib/ARCH/ now

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 08 Feb 2018 16:21:28 -0500
