=== debian/control ===
Source: vowpal-wabbit
Section: science
Priority: optional
Maintainer: Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               libboost-program-options-dev,
			   libboost-python-dev,
			   rapidjson-dev,
               help2man,
               zlib1g-dev,
			   markdown, html2text,
Standards-Version: 4.1.3
Homepage: http://hunch.net/~vw/
Vcs-Browser: http://github.com/yarikoptic/vowpal_wabbit
Vcs-Git: git://github.com/yarikoptic/vowpal_wabbit.git -b debian

Package: vowpal-wabbit
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libvw0 (= ${binary:Version})
Suggests: vowpal-wabbit-doc
Description: fast and scalable online machine learning algorithm
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing

Package: libvw0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast and scalable online machine learning algorithm - dynamic library
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains vowpal-wabbit's dynamic libraries.

Package: libvw-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libvw0 (= ${binary:Version})
Description: fast and scalable online machine learning algorithm - development files
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains development files needed to compile and link programs
 which use vowpal-wabbit's libraries.

Package: vowpal-wabbit-dbg
Section: debug
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, vowpal-wabbit (= ${binary:Version})
Description: fast and scalable online machine learning algorithm - debug files
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains debug symbols for the binaries shipped by vowpal-wabbit
 packages.

Package: vowpal-wabbit-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: vowpal-wabbit
Description: fast and scalable online machine learning algorithm - documentation
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains examples (tests) for vowpal-wabbit.
